use Win32::UserAdmin;
$domain = '';

# First, we pull off the name of the file to load from the command line, and
# load the usernames into an array

$filename = shift @ARGV;

$not_quiet = true;
$verbose = false;

if($filename eq "/v") {
    $verbose = true;
    $filename = shift @ARGV;
} elsif ($filename eq "/q") {
    $not_quiet = false;
    $filename = shift @ARGV;
}

if($filename eq "/d") {
    $domain = shift @ARGV;
    $filename = shift @ARGV;
}
Win32::UserAdmin::GetDomainController('', $domain, $server);

if($filename eq "/c") {
    $create_auto = true;
    $filename = shift @ARGV;
}

open(USERLIST, $filename) || die "unable to load $filename\n";
@ARGV || die "no group names provided\n";

print "Retrieving usernames from $filename...\n" if $not_quiet;
while ($username = <USERLIST>) {
    chomp($username);
    $usernames{$username} = " ";
    print "$username\n" if $verbose;
}

# In order to check for the existence of the groups to which we are adding a user,
# we first need to load the current groups on the system. In order to facilitate
# searching the list we will place the names as index's into a hash table.

print "Retrieving group names from system...\n" if $not_quiet;

Win32::UserAdmin::GetGroups($server, \@groups);
foreach $group(@groups) {
    $system_groups{$group} = " ";
    print "$group\n" if $verbose;
}

foreach $group(@ARGV) {
    if (!$system_groups{$group}) {
        if($create_auto) {
            print "Creating $group_type $group...\n" if $not_quiet;
            Win32::UserAdmin::GroupCreate($server,$group, 'generated by addtogrp script')
                || die "unable to create group";
        } else {
            print "Create the group $group [y/n]? : ";
            if (<STDIN> =~ /^y/i) {
                print "Enter COMMENT details : ";
                $comment = <STDIN>;
                print "Creating $group...\n" if $not_quiet;
                Win32::UserAdmin::GroupCreate($server, $group, $comment)
                    || die "unable to create $group";
            }
        }
        print "Adding users to $group...\n" if $verbose;
        @user_array = keys %usernames;
        Win32::UserAdmin::GroupAddUsers($server, $group, \@user_array);
    } else {
        # we need to load the usernames from a group into
        # a hash to make sure we are not repeating users
        print "$group exists\n" if $not_quiet;
        print "Retrieving users from $group..." if $not_quiet;
        %usertemp = %usernames;
        Win32::UserAdmin::GroupGetMembers($server, $group, \@groupusers);
        foreach $groupuser(@groupusers) {
            print "\n$groupuser";
            if(exists $usertemp{$groupuser}) {
                delete $usertemp{$groupuser};
                print " - match" if $verbose;
            }
        }
        print "\n" if $not_quiet;

        print "Adding users to $group...\n" if $not_quiet;
        @user_array = keys %usertemp;
        Win32::UserAdmin::GroupAddUsers($server, $group, \@user_array);
    }
}
